module SdfParser
  class Engine
    def initialize(args)
      @definition = Definition.new( args[:definition])
      @source     = Source.new(     args[:source]    )
    end

    def inspect
      "#<#{self.class}:#{object_id}>"
    end

    def columns
      @definition.columns
    end

    def parse_line
      Line.new  @source.readline, @definition
    end

    def each_line
      catch :done do
        while true
          yield parse_line
        end
      end
    end

    private
    def create_definition
      Definition.new map
    end
  end
end
