module SdfParser
  class Line

    def initialize(line, definition)
      @line       = line
      @definition = definition
    end

    def parse
      @definition.hash_map.map do |k, v|
        { k => split_data(@line, v) }
      end.reduce(&:merge)
    end

  private
    def split_data(line, address)
      field = line[address[0] - 1, address[1]]
      return field.strip if field
      throw "The data doesn't match the definition"
    end
  end
end
